/* A Bison parser, made by GNU Bison 1.875c.  */

/* Skeleton parser for Yacc-like parsing with Bison,
   Copyright (C) 1984, 1989, 1990, 2000, 2001, 2002, 2003 Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.  */

/* As a special exception, when this file is copied by Bison into a
   Bison output file, you may use that output file without restriction.
   This special exception was added by the Free Software Foundation
   in version 1.24 of Bison.  */

/* Written by Richard Stallman by simplifying the original so called
   ``semantic'' parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 1

/* Using locations.  */
#define YYLSP_NEEDED 0



/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     INTEGER = 258,
     DOUBLE = 259,
     PLAYMODE = 260,
     UNDEFCS = 261,
     UNDEFCV = 262,
     DEFCS = 263,
     DEFCV = 264,
     pt = 265,
     ball = 266,
     oppteam = 267,
     ourteam = 268,
     rec = 269,
     tri = 270,
     regnull = 271,
     ureg = 272,
     arc = 273,
     truecond = 274,
     falsecond = 275,
     ppos = 276,
     bpos = 277,
     bowner = 278,
     playm = 279,
     andcond = 280,
     orcond = 281,
     notcond = 282,
     timecond = 283,
     opp_goals = 284,
     our_goals = 285,
     goal_diff = 286,
     unumcond = 287,
     pos = 288,
     home = 289,
     mark = 290,
     markl = 291,
     oline = 292,
     htype = 293,
     pass = 294,
     dribble = 295,
     clearact = 296,
     shoot = 297,
     hold = 298,
     intercept = 299,
     tackle = 300,
     dirdo = 301,
     dirdont = 302,
     definerule = 303,
     definer = 304,
     definec = 305,
     definea = 306,
     definedir = 307,
     define = 308,
     deleterule = 309,
     ruletoken = 310,
     direc = 311,
     model = 312,
     allrules = 313,
     ruleon = 314,
     ruleoff = 315
   };
#endif
#define INTEGER 258
#define DOUBLE 259
#define PLAYMODE 260
#define UNDEFCS 261
#define UNDEFCV 262
#define DEFCS 263
#define DEFCV 264
#define pt 265
#define ball 266
#define oppteam 267
#define ourteam 268
#define rec 269
#define tri 270
#define regnull 271
#define ureg 272
#define arc 273
#define truecond 274
#define falsecond 275
#define ppos 276
#define bpos 277
#define bowner 278
#define playm 279
#define andcond 280
#define orcond 281
#define notcond 282
#define timecond 283
#define opp_goals 284
#define our_goals 285
#define goal_diff 286
#define unumcond 287
#define pos 288
#define home 289
#define mark 290
#define markl 291
#define oline 292
#define htype 293
#define pass 294
#define dribble 295
#define clearact 296
#define shoot 297
#define hold 298
#define intercept 299
#define tackle 300
#define dirdo 301
#define dirdont 302
#define definerule 303
#define definer 304
#define definec 305
#define definea 306
#define definedir 307
#define define 308
#define deleterule 309
#define ruletoken 310
#define direc 311
#define model 312
#define allrules 313
#define ruleon 314
#define ruleoff 315




/* Copy the first part of user declarations.  */
#line 32 "ClangParse.y"

#include <string.h>
#include "ClangCondition.h"
#include "ClangDirective.h"
#include "ClangTypes.h"
#include "ClangRegion.h"
#include "ClangParse.h"
#include "ClangRule.h"
#include "ClangMsg.h"

#include "ClangRuleBase.h"


int yyerror(char *s);

#define YYPARSE_PARAM ctrl
#define YYLEX_PARAM ctrl
#define YYERROR_VERBOSE

int yylex(void *lvalp, void *ctrl);

bool isEndOfToken(char c);
int lastoff=0;



/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

#if ! defined (YYSTYPE) && ! defined (YYSTYPE_IS_DECLARED)
#line 61 "ClangParse.y"
typedef union YYSTYPE {
	Region *reg;
	PointRegion *ptreg;
	regionList *rlist;
	double real;
	CLTeam tm;
	UnumSet *uns;
	int integer;
	Action *act;
	Condition *cnd;
	CLPlayMode md;
	CondCompOp cndop;
	conditionList *clist;
	Directive *dir;
	actionList *alist;
	directiveList *dlist;
	Rule *rl;
	CLangVar *clv;
	idList *idl;
	ruleList *rllist;


	definemsg *defm;
	
} YYSTYPE;
/* Line 191 of yacc.c.  */
#line 248 "ClangParse.cc"
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
# define YYSTYPE_IS_TRIVIAL 1
#endif



/* Copy the second part of user declarations.  */


/* Line 214 of yacc.c.  */
#line 260 "ClangParse.cc"

#if ! defined (yyoverflow) || YYERROR_VERBOSE

# ifndef YYFREE
#  define YYFREE free
# endif
# ifndef YYMALLOC
#  define YYMALLOC malloc
# endif

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   define YYSTACK_ALLOC alloca
#  endif
# else
#  if defined (alloca) || defined (_ALLOCA_H)
#   define YYSTACK_ALLOC alloca
#  else
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning. */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
# else
#  if defined (__STDC__) || defined (__cplusplus)
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   define YYSIZE_T size_t
#  endif
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
# endif
#endif /* ! defined (yyoverflow) || YYERROR_VERBOSE */


#if (! defined (yyoverflow) \
     && (! defined (__cplusplus) \
	 || (defined (YYSTYPE_IS_TRIVIAL) && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  short yyss;
  YYSTYPE yyvs;
  };

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (short) + sizeof (YYSTYPE))				\
      + YYSTACK_GAP_MAXIMUM)

/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined (__GNUC__) && 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  register YYSIZE_T yyi;		\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];		\
	}					\
      while (0)
#  endif
# endif

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack)					\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack, Stack, yysize);				\
	Stack = &yyptr->Stack;						\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (0)

#endif

#if defined (__STDC__) || defined (__cplusplus)
   typedef signed char yysigned_char;
#else
   typedef short yysigned_char;
#endif

/* YYFINAL -- State number of the termination state. */
#define YYFINAL  6
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   312

/* YYNTOKENS -- Number of terminals. */
#define YYNTOKENS  73
/* YYNNTS -- Number of nonterminals. */
#define YYNNTS  30
/* YYNRULES -- Number of rules. */
#define YYNRULES  122
/* YYNRULES -- Number of states. */
#define YYNSTATES  301

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   315

#define YYTRANSLATE(YYX) 						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const unsigned char yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    66,     2,     2,     2,     2,     2,     2,
      61,    62,    69,    67,     2,    68,     2,    70,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
      64,    63,    65,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    71,     2,    72,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const unsigned short yyprhs[] =
{
       0,     0,     3,     8,    13,    18,    25,    30,    32,    35,
      40,    45,    50,    55,    62,    69,    72,    74,    76,    78,
      80,    82,    84,    90,    96,   102,   108,   114,   120,   126,
     132,   139,   146,   153,   160,   165,   170,   174,   176,   178,
     181,   183,   186,   188,   191,   198,   205,   207,   209,   212,
     216,   220,   229,   234,   240,   245,   251,   253,   258,   263,
     268,   270,   276,   282,   288,   294,   300,   306,   312,   318,
     321,   323,   326,   328,   331,   334,   336,   339,   344,   349,
     354,   359,   364,   369,   374,   379,   384,   389,   394,   398,
     402,   406,   411,   413,   415,   421,   428,   432,   437,   446,
     448,   454,   459,   465,   469,   475,   477,   481,   485,   489,
     493,   498,   500,   502,   505,   507,   509,   511,   513,   517,
     519,   522,   524
};

/* YYRHS -- A `-1'-separated list of the rules' RHS. */
static const yysigned_char yyrhs[] =
{
      74,     0,    -1,    61,    53,    77,    62,    -1,    61,    55,
      75,    62,    -1,    61,    54,    58,    62,    -1,    61,    54,
      61,    86,    62,    62,    -1,    61,    54,     9,    62,    -1,
      76,    -1,    76,    75,    -1,    61,    59,    58,    62,    -1,
      61,    60,    58,    62,    -1,    61,    59,     9,    62,    -1,
      61,    60,     9,    62,    -1,    61,    59,    61,    86,    62,
      62,    -1,    61,    60,    61,    86,    62,    62,    -1,    77,
      78,    -1,    78,    -1,    79,    -1,    80,    -1,    81,    -1,
      82,    -1,    83,    -1,    61,    49,     6,    95,    62,    -1,
      61,    49,     8,    95,    62,    -1,    61,    50,     6,    90,
      62,    -1,    61,    50,     8,    90,    62,    -1,    61,    52,
       6,    88,    62,    -1,    61,    52,     8,    88,    62,    -1,
      61,    51,     6,    94,    62,    -1,    61,    51,     8,    94,
      62,    -1,    61,    48,     7,    57,    84,    62,    -1,    61,
      48,     9,    57,    84,    62,    -1,    61,    48,     7,    56,
      84,    62,    -1,    61,    48,     9,    56,    84,    62,    -1,
      61,    90,    87,    62,    -1,    61,    90,    85,    62,    -1,
      61,    86,    62,    -1,     9,    -1,    84,    -1,    84,    85,
      -1,     9,    -1,     9,    86,    -1,    88,    -1,    88,    87,
      -1,    61,    46,    99,   101,    89,    62,    -1,    61,    47,
      99,   101,    89,    62,    -1,     8,    -1,    94,    -1,    94,
      89,    -1,    61,    19,    62,    -1,    61,    20,    62,    -1,
      61,    21,    99,   101,     3,     3,    95,    62,    -1,    61,
      22,    95,    62,    -1,    61,    23,    99,   101,    62,    -1,
      61,    24,     5,    62,    -1,    61,    32,     7,   101,    62,
      -1,    91,    -1,    61,    25,    93,    62,    -1,    61,    26,
      93,    62,    -1,    61,    27,    90,    62,    -1,     8,    -1,
      61,    28,    92,     3,    62,    -1,    61,     3,    92,    28,
      62,    -1,    61,    29,    92,     3,    62,    -1,    61,     3,
      92,    29,    62,    -1,    61,    30,    92,     3,    62,    -1,
      61,     3,    92,    30,    62,    -1,    61,    31,    92,     3,
      62,    -1,    61,     3,    92,    31,    62,    -1,    63,    63,
      -1,    64,    -1,    64,    63,    -1,    65,    -1,    65,    63,
      -1,    66,    63,    -1,    90,    -1,    90,    93,    -1,    61,
      33,    95,    62,    -1,    61,    34,    95,    62,    -1,    61,
      35,   101,    62,    -1,    61,    36,   101,    62,    -1,    61,
      36,    95,    62,    -1,    61,    37,    95,    62,    -1,    61,
      38,     3,    62,    -1,    61,    39,    95,    62,    -1,    61,
      39,   101,    62,    -1,    61,    40,    95,    62,    -1,    61,
      41,    95,    62,    -1,    61,    42,    62,    -1,    61,    43,
      62,    -1,    61,    44,    62,    -1,    61,    45,   101,    62,
      -1,     8,    -1,    96,    -1,    61,    14,    96,    96,    62,
      -1,    61,    15,    96,    96,    96,    62,    -1,    61,    16,
      62,    -1,    61,    17,    98,    62,    -1,    61,    18,    96,
     100,   100,   100,   100,    62,    -1,     8,    -1,    61,    10,
     100,   100,    62,    -1,    61,    10,    11,    62,    -1,    61,
      10,    99,     3,    62,    -1,    61,    97,    62,    -1,    61,
      10,    99,     7,    62,    -1,     8,    -1,    97,    67,    97,
      -1,    97,    68,    97,    -1,    97,    69,    97,    -1,    97,
      70,    97,    -1,    10,   100,   100,    96,    -1,    96,    -1,
      95,    -1,    95,    98,    -1,    12,    -1,    13,    -1,     4,
      -1,     3,    -1,    71,   102,    72,    -1,     3,    -1,     3,
     102,    -1,     7,    -1,     7,   102,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const unsigned short yyrline[] =
{
       0,   197,   197,   198,   199,   200,   201,   206,   207,   211,
     212,   213,   214,   215,   216,   222,   223,   227,   228,   229,
     230,   231,   235,   236,   252,   253,   257,   258,   262,   263,
     267,   268,   269,   270,   277,   278,   279,   280,   284,   285,
     290,   291,   298,   299,   304,   305,   306,   319,   320,   326,
     327,   328,   329,   330,   331,   332,   333,   334,   335,   336,
     337,   352,   353,   354,   355,   356,   357,   358,   359,   365,
     366,   367,   368,   369,   370,   375,   376,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   413,   414,   415,   416,   417,   418,   419,
     433,   434,   435,   436,   437,   438,   454,   455,   456,   457,
     458,   459,   463,   464,   473,   474,   481,   482,   488,   492,
     493,   494,   495
};
#endif

#if YYDEBUG || YYERROR_VERBOSE
/* YYTNME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals. */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "INTEGER", "DOUBLE", "PLAYMODE",
  "UNDEFCS", "UNDEFCV", "DEFCS", "DEFCV", "\"pt\"", "\"ball\"", "\"opp\"",
  "\"our\"", "\"rec\"", "\"tri\"", "\"null\"", "\"reg\"", "\"arc\"",
  "\"true\"", "\"false\"", "\"ppos\"", "\"bpos\"", "\"bowner\"",
  "\"playm\"", "\"and\"", "\"or\"", "\"not\"", "\"time\"", "\"opp_goals\"",
  "\"our_goals\"", "\"goal_diff\"", "\"unum\"", "\"pos\"", "\"home\"",
  "\"mark\"", "\"markl\"", "\"oline\"", "\"htype\"", "\"pass\"",
  "\"dribble\"", "\"clear\"", "\"shoot\"", "\"hold\"", "\"intercept\"",
  "\"tackle\"", "\"do\"", "\"dont\"", "\"definerule\"", "\"definer\"",
  "\"definec\"", "\"definea\"", "\"defined\"", "\"define\"", "\"delete\"",
  "\"rule\"", "\"direc\"", "\"model\"", "\"all\"", "\"on\"", "\"off\"",
  "'('", "')'", "'='", "'<'", "'>'", "'!'", "'+'", "'-'", "'*'", "'/'",
  "'{'", "'}'", "$accept", "line", "ruleids", "ruleidcomp", "definelist",
  "definecomponent", "definercomp", "defineccomp", "definedcomp",
  "defineacomp", "definerulecomp", "rule", "rulelist", "idlist", "dirlist",
  "directive", "actlist", "condition", "condcomp", "ccop", "condlist",
  "action", "region", "point", "pointarith", "reglist", "team", "NUMBER",
  "UNUMSET", "UNUMSET_WO_BRACES", 0
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const unsigned short yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,    40,    41,    61,    60,    62,    33,    43,    45,    42,
      47,   123,   125
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const unsigned char yyr1[] =
{
       0,    73,    74,    74,    74,    74,    74,    75,    75,    76,
      76,    76,    76,    76,    76,    77,    77,    78,    78,    78,
      78,    78,    79,    79,    80,    80,    81,    81,    82,    82,
      83,    83,    83,    83,    84,    84,    84,    84,    85,    85,
      86,    86,    87,    87,    88,    88,    88,    89,    89,    90,
      90,    90,    90,    90,    90,    90,    90,    90,    90,    90,
      90,    91,    91,    91,    91,    91,    91,    91,    91,    92,
      92,    92,    92,    92,    92,    93,    93,    94,    94,    94,
      94,    94,    94,    94,    94,    94,    94,    94,    94,    94,
      94,    94,    94,    95,    95,    95,    95,    95,    95,    95,
      96,    96,    96,    96,    96,    96,    97,    97,    97,    97,
      97,    97,    98,    98,    99,    99,   100,   100,   101,   102,
     102,   102,   102
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const unsigned char yyr2[] =
{
       0,     2,     4,     4,     4,     6,     4,     1,     2,     4,
       4,     4,     4,     6,     6,     2,     1,     1,     1,     1,
       1,     1,     5,     5,     5,     5,     5,     5,     5,     5,
       6,     6,     6,     6,     4,     4,     3,     1,     1,     2,
       1,     2,     1,     2,     6,     6,     1,     1,     2,     3,
       3,     8,     4,     5,     4,     5,     1,     4,     4,     4,
       1,     5,     5,     5,     5,     5,     5,     5,     5,     2,
       1,     2,     1,     2,     2,     1,     2,     4,     4,     4,
       4,     4,     4,     4,     4,     4,     4,     4,     3,     3,
       3,     4,     1,     1,     5,     6,     3,     4,     8,     1,
       5,     4,     5,     3,     5,     1,     3,     3,     3,     3,
       4,     1,     1,     2,     1,     1,     1,     1,     3,     1,
       2,     1,     2
};

/* YYDEFACT[STATE-NAME] -- Default rule to reduce with in state
   STATE-NUM when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const unsigned char yydefact[] =
{
       0,     0,     0,     0,     0,     0,     1,     0,     0,    16,
      17,    18,    19,    20,    21,     0,     0,     0,     0,     0,
       7,     0,     0,     0,     0,     0,     2,    15,     6,     4,
      40,     0,     0,     0,     3,     8,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    41,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    99,     0,
       0,    93,     0,    60,     0,     0,    56,     0,    92,     0,
       0,     0,    46,     0,     0,     0,     5,    11,     9,     0,
      12,    10,     0,    37,     0,     0,     0,     0,     0,   105,
       0,     0,     0,     0,     0,     0,     0,   111,     0,    22,
      23,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    24,    25,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    28,    29,     0,     0,    26,    27,     0,     0,     0,
       0,    32,    30,    33,    31,   117,   116,     0,   114,   115,
       0,     0,     0,     0,    96,   112,     0,     0,   103,     0,
       0,     0,     0,     0,    70,    72,     0,     0,    49,    50,
       0,     0,     0,     0,    75,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    88,    89,    90,     0,     0,
       0,    13,    14,    36,     0,    38,     0,     0,    42,   101,
       0,     0,     0,     0,     0,   113,    97,     0,     0,   106,
     107,   108,   109,    69,    71,    73,    74,     0,     0,     0,
       0,     0,    52,     0,    54,    76,    57,    58,    59,     0,
       0,     0,     0,     0,    77,    78,   119,   121,     0,    79,
      81,    80,    82,    83,    84,    85,    86,    87,    91,     0,
       0,    39,    35,    34,    43,   102,   104,   100,   110,    94,
       0,     0,     0,    62,    64,    66,    68,     0,    53,    61,
      63,    65,    67,    55,   120,   122,   118,     0,    47,     0,
      95,     0,     0,     0,    44,    48,    45,     0,     0,    98,
      51
};

/* YYDEFGOTO[NTERM-NUM]. */
static const short yydefgoto[] =
{
      -1,     2,    19,    20,     8,     9,    10,    11,    12,    13,
      14,   205,   206,   139,   207,   208,   287,   174,    66,   167,
     175,   288,   155,    61,    98,   156,   150,   151,   186,   248
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -240
static const short yypact[] =
{
     -41,    69,    56,   -33,    48,   -18,  -240,   110,   -53,  -240,
    -240,  -240,  -240,  -240,  -240,    55,    91,    57,    17,   121,
     -18,    46,    44,   148,   176,   200,  -240,  -240,  -240,  -240,
      57,   159,    49,    54,  -240,  -240,    90,   153,     7,     7,
      28,    28,    29,    29,    37,    37,  -240,   160,   161,   162,
      57,   163,   164,    57,    33,    33,    33,    33,  -240,     9,
     165,  -240,   166,  -240,   108,   167,  -240,   168,  -240,   135,
     169,   170,  -240,    53,   172,   174,  -240,  -240,  -240,   177,
    -240,  -240,   179,  -240,    21,   180,   181,   182,   183,  -240,
     138,    40,    40,   184,     7,    40,     4,  -240,    51,  -240,
    -240,   100,   185,   186,   199,     7,   199,   103,    28,    28,
      28,   100,   100,   100,   100,   226,  -240,  -240,     7,     7,
     136,    -2,     7,   234,    -2,     7,     7,   187,   188,   189,
     136,  -240,  -240,   199,   199,  -240,  -240,   190,   191,   192,
      24,  -240,  -240,  -240,  -240,  -240,  -240,   194,  -240,  -240,
     145,   210,    40,    40,  -240,     7,   195,   210,  -240,    36,
      36,    36,    36,   196,   197,   198,   201,   158,  -240,  -240,
     136,   203,   136,   204,    28,   205,   206,   207,   235,   237,
     255,   259,   136,   208,   209,   178,   211,   212,   213,   214,
     215,   216,   217,   218,   219,  -240,  -240,  -240,   220,   136,
     136,  -240,  -240,  -240,    32,    33,   221,   222,    37,  -240,
     223,   224,    -1,   225,    40,  -240,  -240,   210,   210,   123,
     123,   123,   123,  -240,  -240,  -240,  -240,   227,   228,   229,
     230,   260,  -240,   231,  -240,  -240,  -240,  -240,  -240,   232,
     233,   236,   238,   239,  -240,  -240,   178,   178,   240,  -240,
    -240,  -240,  -240,  -240,  -240,  -240,  -240,  -240,  -240,    29,
      29,  -240,  -240,  -240,  -240,  -240,  -240,  -240,  -240,  -240,
     241,   210,   210,  -240,  -240,  -240,  -240,   269,  -240,  -240,
    -240,  -240,  -240,  -240,  -240,  -240,  -240,   242,    29,   243,
    -240,   210,    40,     7,  -240,  -240,  -240,   244,   245,  -240,
    -240
};

/* YYPGOTO[NTERM-NUM].  */
static const short yypgoto[] =
{
    -240,  -240,   268,  -240,  -240,   288,  -240,  -240,  -240,  -240,
    -240,   140,    92,     1,    94,   171,  -239,   -37,  -240,    87,
     -99,   175,   -38,   -57,    43,   144,    10,  -146,  -108,   -27
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If zero, do what YYDEFACT says.
   If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -1
static const unsigned short yytable[] =
{
      60,    62,    97,    65,    67,   212,    58,    89,     7,    26,
     176,   217,    89,   188,    90,    58,   192,    89,    31,    90,
       1,   289,   198,    91,    92,    93,    94,    95,     7,    63,
      30,    46,    72,    83,   152,   153,    63,    68,   157,    97,
      63,    30,    83,    18,    89,    72,   218,   140,    89,   295,
      38,    79,    39,    36,    82,    37,     6,    15,    48,    59,
      96,   267,   231,    51,   233,    96,    30,   171,    59,   185,
      96,   271,   272,   177,   243,   235,    32,    33,   133,   134,
     183,   184,    64,   187,   189,   204,   191,   193,   194,    64,
      69,   259,   260,    64,    84,   213,   214,    96,    73,   133,
     134,    96,    97,    97,    97,    97,    16,    49,   173,    17,
      50,   101,    52,   158,   170,    53,   172,    28,   159,   160,
     161,   162,     3,     4,     5,   291,   292,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   145,   146,   199,   200,   297,    54,    55,   210,   147,
     148,   149,   211,    29,    40,   268,    41,   270,    21,    22,
      23,    24,    25,   163,   164,   165,   166,   140,   118,   119,
     120,   121,   122,   123,   124,   125,   126,   127,   128,   129,
     130,   246,    42,    34,    43,   247,   227,   228,   229,   230,
     159,   160,   161,   162,    85,    86,    87,    88,   178,   179,
     180,   181,   219,   220,   221,   222,    44,   185,    45,    56,
      57,   148,   149,   145,   146,    74,    75,    70,    71,   284,
     285,    47,    76,    77,    78,    80,    81,    99,   100,   116,
     117,   131,   132,   182,   135,   268,   136,   190,   239,   137,
     240,   138,   141,   142,   143,   144,   154,   168,   169,   195,
     196,   197,   201,   202,   203,   298,   209,   216,   241,   223,
     224,   225,   242,   277,   226,   232,   234,   236,   237,   238,
     244,   245,   293,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   262,   263,   265,   266,   269,    35,   273,
     274,   275,   276,   278,   279,   280,    27,   261,   281,   215,
     282,   283,   264,   290,   294,   296,   299,   300,     0,     0,
       0,     0,   286
};

static const short yycheck[] =
{
      38,    39,    59,    40,    41,   151,     8,     8,    61,    62,
     109,   157,     8,   121,    10,     8,   124,     8,    17,    10,
      61,   260,   130,    14,    15,    16,    17,    18,    61,     8,
       9,    30,     8,     9,    91,    92,     8,     8,    95,    96,
       8,     9,     9,    61,     8,     8,    10,    84,     8,   288,
       6,    50,     8,     7,    53,     9,     0,     9,     9,    61,
      61,    62,   170,     9,   172,    61,     9,   105,    61,    71,
      61,   217,   218,   110,   182,   174,    59,    60,    46,    47,
     118,   119,    61,   121,   122,    61,   124,   125,   126,    61,
      61,   199,   200,    61,    61,   152,   153,    61,    61,    46,
      47,    61,   159,   160,   161,   162,    58,    58,     5,    61,
      61,     3,    58,    62,   104,    61,   106,    62,    67,    68,
      69,    70,    53,    54,    55,   271,   272,    19,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    29,    30,    31,
      32,     3,     4,   133,   134,   291,    56,    57,     3,    11,
      12,    13,     7,    62,     6,   212,     8,   214,    48,    49,
      50,    51,    52,    63,    64,    65,    66,   204,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,     3,     6,    62,     8,     7,    28,    29,    30,    31,
      67,    68,    69,    70,    54,    55,    56,    57,   111,   112,
     113,   114,   159,   160,   161,   162,     6,    71,     8,    56,
      57,    12,    13,     3,     4,    44,    45,    42,    43,   246,
     247,    62,    62,    62,    62,    62,    62,    62,    62,    62,
      62,    62,    62,     7,    62,   292,    62,     3,     3,    62,
       3,    62,    62,    62,    62,    62,    62,    62,    62,    62,
      62,    62,    62,    62,    62,   293,    62,    62,     3,    63,
      63,    63,     3,     3,    63,    62,    62,    62,    62,    62,
      62,    62,     3,    62,    62,    62,    62,    62,    62,    62,
      62,    62,    62,    62,    62,    62,    62,    62,    20,    62,
      62,    62,    62,    62,    62,    62,     8,   205,    62,   155,
      62,    62,   208,    62,    62,    62,    62,    62,    -1,    -1,
      -1,    -1,    72
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const unsigned char yystos[] =
{
       0,    61,    74,    53,    54,    55,     0,    61,    77,    78,
      79,    80,    81,    82,    83,     9,    58,    61,    61,    75,
      76,    48,    49,    50,    51,    52,    62,    78,    62,    62,
       9,    86,    59,    60,    62,    75,     7,     9,     6,     8,
       6,     8,     6,     8,     6,     8,    86,    62,     9,    58,
      61,     9,    58,    61,    56,    57,    56,    57,     8,    61,
      95,    96,    95,     8,    61,    90,    91,    90,     8,    61,
      94,    94,     8,    61,    88,    88,    62,    62,    62,    86,
      62,    62,    86,     9,    61,    84,    84,    84,    84,     8,
      10,    14,    15,    16,    17,    18,    61,    96,    97,    62,
      62,     3,    19,    20,    21,    22,    23,    24,    25,    26,
      27,    28,    29,    30,    31,    32,    62,    62,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    62,    62,    46,    47,    62,    62,    62,    62,    86,
      90,    62,    62,    62,    62,     3,     4,    11,    12,    13,
      99,   100,    96,    96,    62,    95,    98,    96,    62,    67,
      68,    69,    70,    63,    64,    65,    66,    92,    62,    62,
      99,    95,    99,     5,    90,    93,    93,    90,    92,    92,
      92,    92,     7,    95,    95,    71,   101,    95,   101,    95,
       3,    95,   101,    95,    95,    62,    62,    62,   101,    99,
      99,    62,    62,    62,    61,    84,    85,    87,    88,    62,
       3,     7,   100,    96,    96,    98,    62,   100,    10,    97,
      97,    97,    97,    63,    63,    63,    63,    28,    29,    30,
      31,   101,    62,   101,    62,    93,    62,    62,    62,     3,
       3,     3,     3,   101,    62,    62,     3,     7,   102,    62,
      62,    62,    62,    62,    62,    62,    62,    62,    62,   101,
     101,    85,    62,    62,    87,    62,    62,    62,    96,    62,
      96,   100,   100,    62,    62,    62,    62,     3,    62,    62,
      62,    62,    62,    62,   102,   102,    72,    89,    94,    89,
      62,   100,   100,     3,    62,    89,    62,   100,    95,    62,
      62
};

#if ! defined (YYSIZE_T) && defined (__SIZE_TYPE__)
# define YYSIZE_T __SIZE_TYPE__
#endif
#if ! defined (YYSIZE_T) && defined (size_t)
# define YYSIZE_T size_t
#endif
#if ! defined (YYSIZE_T)
# if defined (__STDC__) || defined (__cplusplus)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# endif
#endif
#if ! defined (YYSIZE_T)
# define YYSIZE_T unsigned int
#endif

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrorlab


/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */

#define YYFAIL		goto yyerrlab

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      yytoken = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    { 								\
      yyerror ("syntax error: cannot back up");\
      YYERROR;							\
    }								\
while (0)

#define YYTERROR	1
#define YYERRCODE	256

/* YYLLOC_DEFAULT -- Compute the default location (before the actions
   are run).  */

#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)		\
   ((Current).first_line   = (Rhs)[1].first_line,	\
    (Current).first_column = (Rhs)[1].first_column,	\
    (Current).last_line    = (Rhs)[N].last_line,	\
    (Current).last_column  = (Rhs)[N].last_column)
#endif

/* YYLEX -- calling `yylex' with the right arguments.  */

#ifdef YYLEX_PARAM
# define YYLEX yylex (&yylval, YYLEX_PARAM)
#else
# define YYLEX yylex (&yylval)
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (0)

# define YYDSYMPRINT(Args)			\
do {						\
  if (yydebug)					\
    yysymprint Args;				\
} while (0)

# define YYDSYMPRINTF(Title, Token, Value, Location)		\
do {								\
  if (yydebug)							\
    {								\
      YYFPRINTF (stderr, "%s ", Title);				\
      yysymprint (stderr, 					\
                  Token, Value);	\
      YYFPRINTF (stderr, "\n");					\
    }								\
} while (0)

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yy_stack_print (short *bottom, short *top)
#else
static void
yy_stack_print (bottom, top)
    short *bottom;
    short *top;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (/* Nothing. */; bottom <= top; ++bottom)
    YYFPRINTF (stderr, " %d", *bottom);
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yy_reduce_print (int yyrule)
#else
static void
yy_reduce_print (yyrule)
    int yyrule;
#endif
{
  int yyi;
  unsigned int yylno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %u), ",
             yyrule - 1, yylno);
  /* Print the symbols being reduced, and their result.  */
  for (yyi = yyprhs[yyrule]; 0 <= yyrhs[yyi]; yyi++)
    YYFPRINTF (stderr, "%s ", yytname [yyrhs[yyi]]);
  YYFPRINTF (stderr, "-> %s\n", yytname [yyr1[yyrule]]);
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (Rule);		\
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YYDSYMPRINT(Args)
# define YYDSYMPRINTF(Title, Token, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   SIZE_MAX < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#if defined (YYMAXDEPTH) && YYMAXDEPTH == 0
# undef YYMAXDEPTH
#endif

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif



#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined (__GLIBC__) && defined (_STRING_H)
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
#   if defined (__STDC__) || defined (__cplusplus)
yystrlen (const char *yystr)
#   else
yystrlen (yystr)
     const char *yystr;
#   endif
{
  register const char *yys = yystr;

  while (*yys++ != '\0')
    continue;

  return yys - yystr - 1;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined (__GLIBC__) && defined (_STRING_H) && defined (_GNU_SOURCE)
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
#   if defined (__STDC__) || defined (__cplusplus)
yystpcpy (char *yydest, const char *yysrc)
#   else
yystpcpy (yydest, yysrc)
     char *yydest;
     const char *yysrc;
#   endif
{
  register char *yyd = yydest;
  register const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

#endif /* !YYERROR_VERBOSE */



#if YYDEBUG
/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yysymprint (FILE *yyoutput, int yytype, YYSTYPE *yyvaluep)
#else
static void
yysymprint (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  /* Pacify ``unused variable'' warnings.  */
  (void) yyvaluep;

  if (yytype < YYNTOKENS)
    {
      YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
# ifdef YYPRINT
      YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# endif
    }
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);

  switch (yytype)
    {
      default:
        break;
    }
  YYFPRINTF (yyoutput, ")");
}

#endif /* ! YYDEBUG */
/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yydestruct (int yytype, YYSTYPE *yyvaluep)
#else
static void
yydestruct (yytype, yyvaluep)
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  /* Pacify ``unused variable'' warnings.  */
  (void) yyvaluep;

  switch (yytype)
    {

      default:
        break;
    }
}


/* Prevent warnings from -Wmissing-prototypes.  */

#ifdef YYPARSE_PARAM
# if defined (__STDC__) || defined (__cplusplus)
int yyparse (void *YYPARSE_PARAM);
# else
int yyparse ();
# endif
#else /* ! YYPARSE_PARAM */
#if defined (__STDC__) || defined (__cplusplus)
int yyparse (void);
#else
int yyparse ();
#endif
#endif /* ! YYPARSE_PARAM */






/*----------.
| yyparse.  |
`----------*/

#ifdef YYPARSE_PARAM
# if defined (__STDC__) || defined (__cplusplus)
int yyparse (void *YYPARSE_PARAM)
# else
int yyparse (YYPARSE_PARAM)
  void *YYPARSE_PARAM;
# endif
#else /* ! YYPARSE_PARAM */
#if defined (__STDC__) || defined (__cplusplus)
int
yyparse (void)
#else
int
yyparse ()

#endif
#endif
{
  /* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;

/* Number of syntax errors so far.  */
int yynerrs;

  register int yystate;
  register int yyn;
  int yyresult;
  /* Number of tokens to shift before error messages enabled.  */
  int yyerrstatus;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;

  /* Three stacks and their tools:
     `yyss': related to states,
     `yyvs': related to semantic values,
     `yyls': related to locations.

     Refer to the stacks thru separate pointers, to allow yyoverflow
     to reallocate them elsewhere.  */

  /* The state stack.  */
  short	yyssa[YYINITDEPTH];
  short *yyss = yyssa;
  register short *yyssp;

  /* The semantic value stack.  */
  YYSTYPE yyvsa[YYINITDEPTH];
  YYSTYPE *yyvs = yyvsa;
  register YYSTYPE *yyvsp;



#define YYPOPSTACK   (yyvsp--, yyssp--)

  YYSIZE_T yystacksize = YYINITDEPTH;

  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;


  /* When reducing, the number of symbols on the RHS of the reduced
     rule.  */
  int yylen;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss;
  yyvsp = yyvs;

  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed. so pushing a state here evens the stacks.
     */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack. Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	short *yyss1 = yyss;


	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow ("parser stack overflow",
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),

		    &yystacksize);

	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyoverflowlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyoverflowlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	short *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyoverflowlab;
	YYSTACK_RELOCATE (yyss);
	YYSTACK_RELOCATE (yyvs);

#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;


      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

/* Do appropriate processing given the current state.  */
/* Read a lookahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to lookahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYPACT_NINF)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YYDSYMPRINTF ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yyn == 0 || yyn == YYTABLE_NINF)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the lookahead token.  */
  YYDPRINTF ((stderr, "Shifting token %s, ", yytname[yytoken]));

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;


  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  yystate = yyn;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 2:
#line 197 "ClangParse.y"
    {((parsestruct *)ctrl)->itemsdefined = yyvsp[-1].integer; YYACCEPT;;}
    break;

  case 3:
#line 198 "ClangParse.y"
    {((parsestruct *)ctrl)->itemsdefined = -1;YYACCEPT;;}
    break;

  case 4:
#line 199 "ClangParse.y"
    {rulebase->DeleteRule(); YYACCEPT;;}
    break;

  case 5:
#line 200 "ClangParse.y"
    {rulebase->DeleteRule(yyvsp[-2].idl); YYACCEPT;;}
    break;

  case 6:
#line 201 "ClangParse.y"
    {rulebase->DeleteRule(yyvsp[-1].clv); YYACCEPT;;}
    break;

  case 7:
#line 206 "ClangParse.y"
    {;}
    break;

  case 8:
#line 207 "ClangParse.y"
    {;}
    break;

  case 9:
#line 211 "ClangParse.y"
    {rulebase->ChangeRuleState(true);;}
    break;

  case 10:
#line 212 "ClangParse.y"
    {rulebase->ChangeRuleState(false);;}
    break;

  case 11:
#line 213 "ClangParse.y"
    {rulebase->ChangeRuleState(yyvsp[-1].clv,true);;}
    break;

  case 12:
#line 214 "ClangParse.y"
    {rulebase->ChangeRuleState(yyvsp[-1].clv,false);;}
    break;

  case 13:
#line 215 "ClangParse.y"
    {rulebase->ChangeRuleState(yyvsp[-2].idl,true);;}
    break;

  case 14:
#line 216 "ClangParse.y"
    {rulebase->ChangeRuleState(yyvsp[-2].idl,false);;}
    break;

  case 15:
#line 222 "ClangParse.y"
    {yyval.integer = yyvsp[-1].integer+1; rulebase->HearDefineMsg(yyvsp[0].defm);;}
    break;

  case 16:
#line 223 "ClangParse.y"
    {yyval.integer=1;rulebase->HearDefineMsg(yyvsp[0].defm);;}
    break;

  case 22:
#line 235 "ClangParse.y"
    {yyval.defm = new definemsg; yyval.defm->name = yyvsp[-2].clv; yyval.defm->reg = yyvsp[-1].reg; yyval.defm->type = DEFR;;}
    break;

  case 23:
#line 237 "ClangParse.y"
    {
		if (rulebase->IsPointRegion(yyvsp[-2].clv) && !yyvsp[-1].reg->IsPoint())
		{
			char estr[255];
			sprintf(estr,"Warning: Attempting to redefine point region %s as non-point region",yyvsp[-2].clv->GetName());
			yyerror(estr);
		}
		yyval.defm = new definemsg; 
		yyval.defm->name = yyvsp[-2].clv; 
		yyval.defm->reg = yyvsp[-1].reg; 
		yyval.defm->type = DEFR;
	;}
    break;

  case 24:
#line 252 "ClangParse.y"
    {yyval.defm = new definemsg; yyval.defm->name = yyvsp[-2].clv; yyval.defm->cond = yyvsp[-1].cnd; yyval.defm->type = DEFC;;}
    break;

  case 25:
#line 253 "ClangParse.y"
    {yyval.defm = new definemsg; yyval.defm->name = yyvsp[-2].clv; yyval.defm->cond = yyvsp[-1].cnd; yyval.defm->type = DEFC;;}
    break;

  case 26:
#line 257 "ClangParse.y"
    {yyval.defm = new definemsg; yyval.defm->name = yyvsp[-2].clv; yyval.defm->dir = yyvsp[-1].dir; yyval.defm->type = DEFD;;}
    break;

  case 27:
#line 258 "ClangParse.y"
    {yyval.defm = new definemsg; yyval.defm->name = yyvsp[-2].clv; yyval.defm->dir = yyvsp[-1].dir; yyval.defm->type = DEFD;;}
    break;

  case 28:
#line 262 "ClangParse.y"
    {yyval.defm = new definemsg; yyval.defm->name = yyvsp[-2].clv; yyval.defm->act = yyvsp[-1].act; yyval.defm->type = DEFA;;}
    break;

  case 29:
#line 263 "ClangParse.y"
    {yyval.defm = new definemsg; yyval.defm->name = yyvsp[-2].clv; yyval.defm->act = yyvsp[-1].act; yyval.defm->type = DEFA;;}
    break;

  case 30:
#line 267 "ClangParse.y"
    {yyval.defm = new definemsg; yyval.defm->name = yyvsp[-3].clv; yyval.defm->rl = yyvsp[-1].rl; yyval.defm->type = DEFRL;yyval.defm->rlon = 0;  yyval.defm->rldirecmode = false;;}
    break;

  case 31:
#line 268 "ClangParse.y"
    {yyval.defm = new definemsg; yyval.defm->name = yyvsp[-3].clv; yyval.defm->rl = yyvsp[-1].rl; yyval.defm->type = DEFRL;yyval.defm->rlon = 0;  yyval.defm->rldirecmode = false;;}
    break;

  case 32:
#line 269 "ClangParse.y"
    {yyval.defm = new definemsg; yyval.defm->name = yyvsp[-3].clv; yyval.defm->rl = yyvsp[-1].rl; yyval.defm->type = DEFRL; yyval.defm->rlon = 0;  yyval.defm->rldirecmode = true;;}
    break;

  case 33:
#line 270 "ClangParse.y"
    {yyval.defm = new definemsg; yyval.defm->name = yyvsp[-3].clv; yyval.defm->rl = yyvsp[-1].rl; yyval.defm->type = DEFRL; yyval.defm->rlon = 0;  yyval.defm->rldirecmode = true;;}
    break;

  case 34:
#line 277 "ClangParse.y"
    {yyval.rl = new CondDirRule(yyvsp[-2].cnd,yyvsp[-1].dlist);;}
    break;

  case 35:
#line 278 "ClangParse.y"
    {yyval.rl = new CondRuleRule(yyvsp[-2].cnd,yyvsp[-1].rllist);;}
    break;

  case 36:
#line 279 "ClangParse.y"
    {yyval.rl = new IDListRule(yyvsp[-1].idl);;}
    break;

  case 37:
#line 280 "ClangParse.y"
    {idList *l = new idList; l->r = yyvsp[0].clv; l->next = NULL; yyval.rl = new IDListRule(l);;}
    break;

  case 38:
#line 284 "ClangParse.y"
    {yyval.rllist = new ruleList; yyval.rllist->r = yyvsp[0].rl; yyval.rllist->next = NULL;;}
    break;

  case 39:
#line 285 "ClangParse.y"
    {yyval.rllist = new ruleList; yyval.rllist->r= yyvsp[-1].rl; yyval.rllist->next =yyvsp[0].rllist;;}
    break;

  case 40:
#line 290 "ClangParse.y"
    {yyval.idl = new idList; yyval.idl->r = yyvsp[0].clv; yyval.idl->next = NULL;;}
    break;

  case 41:
#line 291 "ClangParse.y"
    {yyval.idl = new idList; yyval.idl->r = yyvsp[-1].clv; yyval.idl->next = yyvsp[0].idl;;}
    break;

  case 42:
#line 298 "ClangParse.y"
    {yyval.dlist = new directiveList; yyval.dlist->next = NULL; yyval.dlist->dir = yyvsp[0].dir;;}
    break;

  case 43:
#line 299 "ClangParse.y"
    {yyval.dlist = new directiveList; yyval.dlist->next = yyvsp[0].dlist; yyval.dlist->dir = yyvsp[-1].dir;;}
    break;

  case 44:
#line 304 "ClangParse.y"
    {yyval.dir = new StdDirective(yyvsp[-1].alist, yyvsp[-3].tm, yyvsp[-2].uns, true);;}
    break;

  case 45:
#line 305 "ClangParse.y"
    {yyval.dir = new StdDirective(yyvsp[-1].alist, yyvsp[-3].tm, yyvsp[-2].uns, false);;}
    break;

  case 46:
#line 306 "ClangParse.y"
    {
			if (!rulebase->IsDirective(yyvsp[0].clv))
			{
				char estr[255];
				sprintf(estr,"%s is not defined as a directive", yyvsp[0].clv->GetName());
				yyerror(estr);
				YYERROR; 
			}
			yyval.dir = new VarDirective(yyvsp[0].clv);
		;}
    break;

  case 47:
#line 319 "ClangParse.y"
    {yyval.alist = new actionList; yyval.alist->next = NULL; yyval.alist->act = yyvsp[0].act;;}
    break;

  case 48:
#line 320 "ClangParse.y"
    {yyval.alist = new actionList; yyval.alist->next = yyvsp[0].alist; yyval.alist->act = yyvsp[-1].act;;}
    break;

  case 49:
#line 326 "ClangParse.y"
    {yyval.cnd = new TrueCondition();;}
    break;

  case 50:
#line 327 "ClangParse.y"
    {yyval.cnd = new FalseCondition();;}
    break;

  case 51:
#line 328 "ClangParse.y"
    {yyval.cnd = new PPosCondition(yyvsp[-5].tm,yyvsp[-4].uns,yyvsp[-3].integer,yyvsp[-2].integer,yyvsp[-1].reg);;}
    break;

  case 52:
#line 329 "ClangParse.y"
    {yyval.cnd = new BPosCondition(yyvsp[-1].reg);;}
    break;

  case 53:
#line 330 "ClangParse.y"
    {yyval.cnd = new BOwnerCondition(yyvsp[-2].tm,yyvsp[-1].uns);;}
    break;

  case 54:
#line 331 "ClangParse.y"
    {yyval.cnd = new PlayMCondition(yyvsp[-1].md);;}
    break;

  case 55:
#line 332 "ClangParse.y"
    {yyval.cnd = new UnumCondition(yyvsp[-2].clv,yyvsp[-1].uns);;}
    break;

  case 57:
#line 334 "ClangParse.y"
    {yyval.cnd = new AndCondition(yyvsp[-1].clist);;}
    break;

  case 58:
#line 335 "ClangParse.y"
    {yyval.cnd = new OrCondition(yyvsp[-1].clist);;}
    break;

  case 59:
#line 336 "ClangParse.y"
    {yyval.cnd = new NotCondition(yyvsp[-1].cnd);;}
    break;

  case 60:
#line 337 "ClangParse.y"
    {
			if (!rulebase->IsCondition(yyvsp[0].clv))
			{
				char estr[255];
				sprintf(estr,"%s is not defined as a condition", yyvsp[0].clv->GetName());
				yyerror(estr);
				YYERROR; 
			}
			yyval.cnd = new VarCondition(yyvsp[0].clv);
		;}
    break;

  case 61:
#line 352 "ClangParse.y"
    {yyval.cnd = new CondComp(svtime,0,yyvsp[-2].cndop,constant,yyvsp[-1].integer);;}
    break;

  case 62:
#line 353 "ClangParse.y"
    {yyval.cnd = new CondComp(constant,yyvsp[-3].integer,yyvsp[-2].cndop,svtime,0);;}
    break;

  case 63:
#line 354 "ClangParse.y"
    {yyval.cnd = new CondComp(oppgoals,0,yyvsp[-2].cndop,constant,yyvsp[-1].integer);;}
    break;

  case 64:
#line 355 "ClangParse.y"
    {yyval.cnd = new CondComp(constant,yyvsp[-3].integer,yyvsp[-2].cndop,oppgoals,0);;}
    break;

  case 65:
#line 356 "ClangParse.y"
    {yyval.cnd = new CondComp(ourgoals,0,yyvsp[-2].cndop,constant,yyvsp[-1].integer);;}
    break;

  case 66:
#line 357 "ClangParse.y"
    {yyval.cnd = new CondComp(constant,yyvsp[-3].integer,yyvsp[-2].cndop,ourgoals,0);;}
    break;

  case 67:
#line 358 "ClangParse.y"
    {yyval.cnd = new CondComp(goaldiff,0,yyvsp[-2].cndop,constant,yyvsp[-1].integer);;}
    break;

  case 68:
#line 359 "ClangParse.y"
    {yyval.cnd = new CondComp(constant,yyvsp[-3].integer,yyvsp[-2].cndop,goaldiff,0);;}
    break;

  case 69:
#line 365 "ClangParse.y"
    {yyval.cndop = eq;;}
    break;

  case 70:
#line 366 "ClangParse.y"
    {yyval.cndop = lt;;}
    break;

  case 71:
#line 367 "ClangParse.y"
    {yyval.cndop = lte;;}
    break;

  case 72:
#line 368 "ClangParse.y"
    {yyval.cndop = gt;;}
    break;

  case 73:
#line 369 "ClangParse.y"
    {yyval.cndop = gte;;}
    break;

  case 74:
#line 370 "ClangParse.y"
    {yyval.cndop = neq;;}
    break;

  case 75:
#line 375 "ClangParse.y"
    {yyval.clist = new conditionList(); yyval.clist->next = NULL; yyval.clist->cond = yyvsp[0].cnd;;}
    break;

  case 76:
#line 376 "ClangParse.y"
    {yyval.clist = new conditionList(); yyval.clist->next = yyvsp[0].clist; yyval.clist->cond = yyvsp[-1].cnd;;}
    break;

  case 77:
#line 383 "ClangParse.y"
    {yyval.act = new StdAction(POS,yyvsp[-1].reg,0,NULL);;}
    break;

  case 78:
#line 384 "ClangParse.y"
    {yyval.act = new StdAction(HOME,yyvsp[-1].reg,0,NULL);;}
    break;

  case 79:
#line 385 "ClangParse.y"
    {yyval.act = new StdAction(MARK,NULL,0,yyvsp[-1].uns);;}
    break;

  case 80:
#line 386 "ClangParse.y"
    {yyval.act = new StdAction(MARKLUNUM,NULL,0,yyvsp[-1].uns);;}
    break;

  case 81:
#line 387 "ClangParse.y"
    {yyval.act = new StdAction(MARKLREG,yyvsp[-1].reg,0,NULL);;}
    break;

  case 82:
#line 388 "ClangParse.y"
    {yyval.act = new StdAction(OLINE,yyvsp[-1].reg,0,NULL);;}
    break;

  case 83:
#line 389 "ClangParse.y"
    {yyval.act = new StdAction(HTYPE,NULL,yyvsp[-1].integer,NULL);;}
    break;

  case 84:
#line 390 "ClangParse.y"
    {yyval.act = new StdAction(PASSREG,yyvsp[-1].reg,0,NULL);;}
    break;

  case 85:
#line 391 "ClangParse.y"
    {yyval.act = new StdAction(PASSUNUM, NULL,0,yyvsp[-1].uns);;}
    break;

  case 86:
#line 392 "ClangParse.y"
    {yyval.act = new StdAction(DRIBBLE,yyvsp[-1].reg,0,NULL);;}
    break;

  case 87:
#line 393 "ClangParse.y"
    {yyval.act = new StdAction(CLEAR,yyvsp[-1].reg,0,NULL);;}
    break;

  case 88:
#line 394 "ClangParse.y"
    {yyval.act = new StdAction(SHOOT,NULL,0,NULL);;}
    break;

  case 89:
#line 395 "ClangParse.y"
    {yyval.act = new StdAction(HOLD,NULL,0,NULL);;}
    break;

  case 90:
#line 396 "ClangParse.y"
    {yyval.act = new StdAction(INTERCEPT,NULL,0,NULL);;}
    break;

  case 91:
#line 397 "ClangParse.y"
    {yyval.act = new StdAction(TACKLE,NULL,0,yyvsp[-1].uns);;}
    break;

  case 92:
#line 398 "ClangParse.y"
    {
			if (!rulebase->IsAction(yyvsp[0].clv))
			{
				char estr[255];
				sprintf(estr,"%s is not defined as a action", yyvsp[0].clv->GetName());
				yyerror(estr);
				YYERROR; 
			}
			yyval.act = new VarAction(yyvsp[0].clv);
		;}
    break;

  case 93:
#line 413 "ClangParse.y"
    {yyval.reg = (Region *)yyvsp[0].ptreg;;}
    break;

  case 94:
#line 414 "ClangParse.y"
    {yyval.reg = new RectRegion(yyvsp[-2].ptreg,yyvsp[-1].ptreg);;}
    break;

  case 95:
#line 415 "ClangParse.y"
    {yyval.reg = new TriRegion(yyvsp[-3].ptreg,yyvsp[-2].ptreg,yyvsp[-1].ptreg);;}
    break;

  case 96:
#line 416 "ClangParse.y"
    {yyval.reg = new NullRegion;;}
    break;

  case 97:
#line 417 "ClangParse.y"
    {yyval.reg = new UnionRegion(yyvsp[-1].rlist);;}
    break;

  case 98:
#line 418 "ClangParse.y"
    {yyval.reg = new ArcRegion(yyvsp[-5].ptreg, yyvsp[-4].real, yyvsp[-3].real, yyvsp[-2].real, yyvsp[-1].real);;}
    break;

  case 99:
#line 419 "ClangParse.y"
    {
			if (!rulebase->IsRegion(yyvsp[0].clv))
			{
				char estr[255];
				sprintf(estr,"%s is not defined as a region", yyvsp[0].clv->GetName());
				yyerror(estr);
				YYERROR; 
			}
			yyval.reg = new VarRegion(yyvsp[0].clv);
		;}
    break;

  case 100:
#line 433 "ClangParse.y"
    {yyval.ptreg = new PointRegion(yyvsp[-2].real,yyvsp[-1].real);;}
    break;

  case 101:
#line 434 "ClangParse.y"
    {yyval.ptreg = new PointRegion(our,0);;}
    break;

  case 102:
#line 435 "ClangParse.y"
    {yyval.ptreg = new PointRegion(yyvsp[-2].tm,yyvsp[-1].integer);;}
    break;

  case 103:
#line 436 "ClangParse.y"
    {yyval.ptreg = yyvsp[-1].ptreg;;}
    break;

  case 104:
#line 437 "ClangParse.y"
    {yyval.ptreg = new UnumSetPoint(yyvsp[-2].tm,yyvsp[-1].clv);;}
    break;

  case 105:
#line 438 "ClangParse.y"
    {
			if (!rulebase->IsPointRegion(yyvsp[0].clv))
			{
				char estr[255];
				sprintf(estr,"%s is not defined as a point", yyvsp[0].clv->GetName());
				yyerror(estr);
				YYERROR; 
			}
			yyval.ptreg = new VarPtRegion(yyvsp[0].clv);
		;}
    break;

  case 106:
#line 454 "ClangParse.y"
    {yyval.ptreg = new PointArithRegion(yyvsp[-2].ptreg,yyvsp[0].ptreg,PTADD);;}
    break;

  case 107:
#line 455 "ClangParse.y"
    {yyval.ptreg = new PointArithRegion(yyvsp[-2].ptreg,yyvsp[0].ptreg,PTSUBTRACT);;}
    break;

  case 108:
#line 456 "ClangParse.y"
    {yyval.ptreg = new PointArithRegion(yyvsp[-2].ptreg,yyvsp[0].ptreg,PTMULTIPLY);;}
    break;

  case 109:
#line 457 "ClangParse.y"
    {yyval.ptreg = new PointArithRegion(yyvsp[-2].ptreg,yyvsp[0].ptreg,PTDIVIDE);;}
    break;

  case 110:
#line 458 "ClangParse.y"
    {yyval.ptreg = new PointArithRegion(new PointRegion(yyvsp[-2].real, yyvsp[-1].real), yyvsp[0].ptreg, PTADD);;}
    break;

  case 112:
#line 463 "ClangParse.y"
    {yyval.rlist = new regionList; yyval.rlist->next = NULL; yyval.rlist->reg = yyvsp[0].reg;;}
    break;

  case 113:
#line 464 "ClangParse.y"
    {yyval.rlist=new regionList; yyval.rlist->next = yyvsp[0].rlist; yyval.rlist->reg = yyvsp[-1].reg;;}
    break;

  case 114:
#line 473 "ClangParse.y"
    {yyval.tm = opp;;}
    break;

  case 115:
#line 474 "ClangParse.y"
    {yyval.tm = our;;}
    break;

  case 117:
#line 482 "ClangParse.y"
    {yyval.real = (double)yyvsp[0].integer;;}
    break;

  case 118:
#line 488 "ClangParse.y"
    {yyval.uns = yyvsp[-1].uns;;}
    break;

  case 119:
#line 492 "ClangParse.y"
    {yyval.uns = new UnumSet(); yyval.uns->Set(yyvsp[0].integer);;}
    break;

  case 120:
#line 493 "ClangParse.y"
    {yyval.uns = yyvsp[0].uns; yyval.uns->Set(yyvsp[-1].integer);;}
    break;

  case 121:
#line 494 "ClangParse.y"
    {yyval.uns = new UnumSet(); yyval.uns->SetCLangVar(yyvsp[0].clv);;}
    break;

  case 122:
#line 495 "ClangParse.y"
    {yyval.uns = yyvsp[0].uns; yyval.uns->SetCLangVar(yyvsp[-1].clv);;}
    break;


    }

/* Line 1000 of yacc.c.  */
#line 2034 "ClangParse.cc"

  yyvsp -= yylen;
  yyssp -= yylen;


  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;


  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (YYPACT_NINF < yyn && yyn < YYLAST)
	{
	  YYSIZE_T yysize = 0;
	  int yytype = YYTRANSLATE (yychar);
	  const char* yyprefix;
	  char *yymsg;
	  int yyx;

	  /* Start YYX at -YYN if negative to avoid negative indexes in
	     YYCHECK.  */
	  int yyxbegin = yyn < 0 ? -yyn : 0;

	  /* Stay within bounds of both yycheck and yytname.  */
	  int yychecklim = YYLAST - yyn;
	  int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
	  int yycount = 0;

	  yyprefix = ", expecting ";
	  for (yyx = yyxbegin; yyx < yyxend; ++yyx)
	    if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
	      {
		yysize += yystrlen (yyprefix) + yystrlen (yytname [yyx]);
		yycount += 1;
		if (yycount == 5)
		  {
		    yysize = 0;
		    break;
		  }
	      }
	  yysize += (sizeof ("syntax error, unexpected ")
		     + yystrlen (yytname[yytype]));
	  yymsg = (char *) YYSTACK_ALLOC (yysize);
	  if (yymsg != 0)
	    {
	      char *yyp = yystpcpy (yymsg, "syntax error, unexpected ");
	      yyp = yystpcpy (yyp, yytname[yytype]);

	      if (yycount < 5)
		{
		  yyprefix = ", expecting ";
		  for (yyx = yyxbegin; yyx < yyxend; ++yyx)
		    if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
		      {
			yyp = yystpcpy (yyp, yyprefix);
			yyp = yystpcpy (yyp, yytname[yyx]);
			yyprefix = " or ";
		      }
		}
	      yyerror (yymsg);
	      YYSTACK_FREE (yymsg);
	    }
	  else
	    yyerror ("syntax error; also virtual memory exhausted");
	}
      else
#endif /* YYERROR_VERBOSE */
	yyerror ("syntax error");
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* If at end of input, pop the error token,
	     then the rest of the stack, then return failure.  */
	  if (yychar == YYEOF)
	     for (;;)
	       {
		 YYPOPSTACK;
		 if (yyssp == yyss)
		   YYABORT;
		 YYDSYMPRINTF ("Error: popping", yystos[*yyssp], yyvsp, yylsp);
		 yydestruct (yystos[*yyssp], yyvsp);
	       }
        }
      else
	{
	  YYDSYMPRINTF ("Error: discarding", yytoken, &yylval, &yylloc);
	  yydestruct (yytoken, &yylval);
	  yychar = YYEMPTY;

	}
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

#ifdef __GNUC__
  /* Pacify GCC when the user code never invokes YYERROR and the label
     yyerrorlab therefore never appears in user code.  */
  if (0)
     goto yyerrorlab;
#endif

  yyvsp -= yylen;
  yyssp -= yylen;
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (yyn != YYPACT_NINF)
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;

      YYDSYMPRINTF ("Error: popping", yystos[*yyssp], yyvsp, yylsp);
      yydestruct (yystos[yystate], yyvsp);
      YYPOPSTACK;
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  if (yyn == YYFINAL)
    YYACCEPT;

  YYDPRINTF ((stderr, "Shifting error token, "));

  *++yyvsp = yylval;


  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#ifndef yyoverflow
/*----------------------------------------------.
| yyoverflowlab -- parser overflow comes here.  |
`----------------------------------------------*/
yyoverflowlab:
  yyerror ("parser stack overflow");
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
  return yyresult;
}


#line 500 "ClangParse.y"




bool isWhitespace(char c)
{
	return (c == ' ') || (c == '\t') || (c == '\r') || (c == '\n');
}

bool isDouble(char *c)
{
	char *ep;
	strtof(c,&ep);
	if (ep > c && isEndOfToken(*ep))
		return true;
	return false;
}

bool isInteger(char *c)
{
	char *ep;
	strtol(c,&ep,10);
	if (ep > c && isEndOfToken(*ep))
		return true;
	return false;

}

bool isEndOfToken(char c)
{
        return isWhitespace(c) || c == ')' || c == '}' || c=='(' || c == '{' || c == '\0';
}

int yylex(void *lvalpt, void *ctrlp)
{
	parsestruct *ctrl = (parsestruct *)ctrlp;
#ifdef CL_LEX_DEBUG
	//cout << "'" << ctrl->str[ctrl->off] << "'" << endl;
	cout << "'";
	for (int i=lastoff;i<ctrl->off;i++)
		cout << ctrl->str[i];
	cout << "'" << endl;
	lastoff = ctrl->off;
#endif
        //cout << &ctrl->str[ctrl->off] << endl;
	YYSTYPE *lvalp = (YYSTYPE *)lvalpt;
	// skip whitespace
	while (isWhitespace(ctrl->str[ctrl->off]))
		ctrl->off++;
	if (ctrl->str[ctrl->off] == '\"')
	{
		int cso = 1;
		char cs[255];
		cs[0] = '\"';
		ctrl->off++;
		while (ctrl->str[ctrl->off] != '\"')
		{
			cs[cso++] = ctrl->str[ctrl->off++];
		}
		cs[cso] = '\"';
		cso++;
		ctrl->off++;
		cs[cso] = '\0';
		lvalp->clv = new CLangVar(cs);
		
		if (rulebase->IsDefinedStr(lvalp->clv))
			return DEFCS;
		else
			return UNDEFCS;
		
	}
	else if (ctrl->str[ctrl->off] == '(')
	{
		ctrl->off++;
		
		return '(';
	}
	else if (ctrl->str[ctrl->off] == ')')
	{
		
		ctrl->off++;
		return ')';
	}
	else if (ctrl->str[ctrl->off] == '{')
	{
		ctrl->off++;
		return '{';
	}
	else if (ctrl->str[ctrl->off] == '}')
	{
		ctrl->off++;
		return '}';
	}
	else if (ctrl->str[ctrl->off] == '=')
	{
		ctrl->off++;
		return '=';
	}
	else if (ctrl->str[ctrl->off] == '|')
	{
		ctrl->off++;
		return '|';
	}
	else if (ctrl->str[ctrl->off] == '>')
	{
		ctrl->off++;
		return '>';
	}
	else if (ctrl->str[ctrl->off] == '<')
	{
		ctrl->off++;
		return '<';
	}
	else if (ctrl->str[ctrl->off] == '+' && isEndOfToken(ctrl->str[ctrl->off+1]))
	{
		ctrl->off++;
		return '+';
	}
	else if (ctrl->str[ctrl->off] == '-' && isEndOfToken(ctrl->str[ctrl->off+1]))
	{
		ctrl->off++;
		return '-';
	}
	else if (ctrl->str[ctrl->off] == '*')
	{
		ctrl->off++;
		return '*';
	}
	else if (ctrl->str[ctrl->off] == '/')
	{
		ctrl->off++;
		return '/';
	}
	else if (ctrl->str[ctrl->off] == '!')
	{
		ctrl->off++;
		return '!';
	}
	
	else if (strncmp(&ctrl->str[ctrl->off],"pt",2) == 0 && isEndOfToken(ctrl->str[ctrl->off+2]))
	{

		ctrl->off += 2;
		return pt;
	}
	else if (strncmp(&ctrl->str[ctrl->off],"ball",4) == 0  && isEndOfToken(ctrl->str[ctrl->off+4]))
	{
		ctrl->off += 4;		
		return ball;
	}
	else if (strncmp(&ctrl->str[ctrl->off],"opp",3) == 0 && isEndOfToken(ctrl->str[ctrl->off+3]))
	{
		ctrl->off += 3;
		return oppteam;
	}
	else if (strncmp(&ctrl->str[ctrl->off],"our",3) == 0 && isEndOfToken(ctrl->str[ctrl->off+3]))
	{
		ctrl->off += 3;
		return ourteam;
	}
	else if (strncmp(&ctrl->str[ctrl->off],"rec",3) == 0 && isEndOfToken(ctrl->str[ctrl->off+3]))
	{
		ctrl->off += 3;
		return rec;
	}
	else if (strncmp(&ctrl->str[ctrl->off],"null",4) == 0 && isEndOfToken(ctrl->str[ctrl->off+4]))
	{
		ctrl->off += 4;
		return regnull;
	}
	else if (strncmp(&ctrl->str[ctrl->off],"arc",3) == 0 && isEndOfToken(ctrl->str[ctrl->off+3]))
	{
		ctrl->off += 3;
		return arc;
	}
	else if (strncmp(&ctrl->str[ctrl->off],"reg",3) == 0 && isEndOfToken(ctrl->str[ctrl->off+3]))
	{

		ctrl->off += 3;
		return ureg;
	}
	else if (strncmp(&ctrl->str[ctrl->off],"tri",3) == 0 && isEndOfToken(ctrl->str[ctrl->off+3]))
	{

		ctrl->off += 3;
		return tri;
	}
	else if (strncmp(&ctrl->str[ctrl->off],"pos",3) == 0 && isEndOfToken(ctrl->str[ctrl->off+3]))
	{

		ctrl->off += 3;
		return pos;
	}
	else if (strncmp(&ctrl->str[ctrl->off],"markl",5) == 0 && isEndOfToken(ctrl->str[ctrl->off+5]))
	{

		ctrl->off += 5;
		return markl;
	}
	else if (strncmp(&ctrl->str[ctrl->off],"home",4) == 0 && isEndOfToken(ctrl->str[ctrl->off+4]))
	{

		ctrl->off += 4;
		return home;
	}
	else if (strncmp(&ctrl->str[ctrl->off],"mark",4) == 0 && isEndOfToken(ctrl->str[ctrl->off+4]))
	{

		ctrl->off += 4;
		return mark;
	}
	else if (strncmp(&ctrl->str[ctrl->off],"oline",5) == 0 && isEndOfToken(ctrl->str[ctrl->off+5]))
	{

		ctrl->off += 5;
		return oline;
	}
	else if (strncmp(&ctrl->str[ctrl->off],"htype",5) == 0 && isEndOfToken(ctrl->str[ctrl->off+5]))
	{

		ctrl->off += 5;
		return htype;
	}
	else if (strncmp(&ctrl->str[ctrl->off],"pass",4) == 0 && isEndOfToken(ctrl->str[ctrl->off+4]))
	{

		ctrl->off += 4;
		return pass;
	}
	else if (strncmp(&ctrl->str[ctrl->off],"dribble",7) == 0 && isEndOfToken(ctrl->str[ctrl->off+7]))
	{

		ctrl->off += 7;
		return dribble;
	}
	else if (strncmp(&ctrl->str[ctrl->off],"clear",5) == 0 && isEndOfToken(ctrl->str[ctrl->off+5]))
	{

		ctrl->off += 5;
		return clearact;
	}
	else if (strncmp(&ctrl->str[ctrl->off],"shoot",5) == 0 && isEndOfToken(ctrl->str[ctrl->off+5]))
	{

		ctrl->off += 5;
		return shoot;
	}
	else if (strncmp(&ctrl->str[ctrl->off],"hold",4) == 0 && isEndOfToken(ctrl->str[ctrl->off+4]))
	{

		ctrl->off += 4;
		return hold;
	}
	else if (strncmp(&ctrl->str[ctrl->off],"intercept",9) == 0 && isEndOfToken(ctrl->str[ctrl->off+9]))
	{

		ctrl->off += 9;
		return intercept;
	}
	else if (strncmp(&ctrl->str[ctrl->off],"tackle",6) == 0 && isEndOfToken(ctrl->str[ctrl->off+6]))
	{

		ctrl->off += 6;
		return tackle;
	}
	else if (strncmp(&ctrl->str[ctrl->off],"true",4) == 0 && isEndOfToken(ctrl->str[ctrl->off+4]))
	{

		ctrl->off += 4;
		return truecond;
	}
	else if (strncmp(&ctrl->str[ctrl->off],"false",5) == 0 && isEndOfToken(ctrl->str[ctrl->off+5]))
	{

		ctrl->off += 5;
		return falsecond;
	}
	else if (strncmp(&ctrl->str[ctrl->off],"ppos",4) == 0 && isEndOfToken(ctrl->str[ctrl->off+4]))
	{

		ctrl->off += 4;
		return ppos;
	}
	else if (strncmp(&ctrl->str[ctrl->off],"bpos",4) == 0 && isEndOfToken(ctrl->str[ctrl->off+4]))
	{

		ctrl->off += 4;
		return bpos;
	}
	else if (strncmp(&ctrl->str[ctrl->off],"playm",5) == 0 && isEndOfToken(ctrl->str[ctrl->off+5]))
	{

		ctrl->off += 5;
		return playm;
	}
	else if (strncmp(&ctrl->str[ctrl->off],"bowner",6) == 0 && isEndOfToken(ctrl->str[ctrl->off+6]))
	{

		ctrl->off += 6;
		return bowner;
	}
	else if (strncmp(&ctrl->str[ctrl->off],"and",3) == 0 && isEndOfToken(ctrl->str[ctrl->off+3]))
	{

		ctrl->off += 3;
		return andcond;
	}
	else if (strncmp(&ctrl->str[ctrl->off],"or",2) == 0 && isEndOfToken(ctrl->str[ctrl->off+2]))
	{

		ctrl->off += 2;
		return orcond;
	}
	else if (strncmp(&ctrl->str[ctrl->off],"not",3) == 0 && isEndOfToken(ctrl->str[ctrl->off+3]))
	{

		ctrl->off += 3;
		return notcond;
	}
	else if (strncmp(&ctrl->str[ctrl->off],"unum",4) == 0 && isEndOfToken(ctrl->str[ctrl->off+4]))
	{

		ctrl->off += 4;
		return unumcond;
	}
	else if (strncmp(&ctrl->str[ctrl->off],"time_over",9) == 0 && isEndOfToken(ctrl->str[ctrl->off+9]))
	{
		lvalp->md = time_over;
		ctrl->off += 9;
		return PLAYMODE;
	}
	else if (strncmp(&ctrl->str[ctrl->off],"time",4) == 0 && isEndOfToken(ctrl->str[ctrl->off+4]))
	{

		ctrl->off += 4;
		return timecond;
	}
	else if (strncmp(&ctrl->str[ctrl->off],"opp_goals",9) == 0 && isEndOfToken(ctrl->str[ctrl->off+9]))
	{

		ctrl->off += 9;
		return opp_goals;
	}
	else if (strncmp(&ctrl->str[ctrl->off],"our_goals",9) == 0 && isEndOfToken(ctrl->str[ctrl->off+9]))
	{

		ctrl->off += 9;
		return our_goals;
	}
	else if (strncmp(&ctrl->str[ctrl->off],"goal_diff",9) == 0 && isEndOfToken(ctrl->str[ctrl->off+9]))
	{

		ctrl->off += 9;
		return goal_diff;
	}
	else if (strncmp(&ctrl->str[ctrl->off],"play_on",7) == 0 && isEndOfToken(ctrl->str[ctrl->off+7]))
	{
		lvalp->md = play_on;
		ctrl->off += 7;
		return PLAYMODE;
	}
	else if (strncmp(&ctrl->str[ctrl->off],"bko",3) == 0 && isEndOfToken(ctrl->str[ctrl->off+3]))
	{
		lvalp->md = bko;
		ctrl->off += 3;
		return PLAYMODE;
	}
	else if (strncmp(&ctrl->str[ctrl->off],"ko_our",6) == 0 && isEndOfToken(ctrl->str[ctrl->off+6]))
	{
		lvalp->md = ko_our;
		ctrl->off += 6;
		return PLAYMODE;
	}
	else if (strncmp(&ctrl->str[ctrl->off],"ko_opp",6) == 0 && isEndOfToken(ctrl->str[ctrl->off+6]))
	{
		lvalp->md = ko_opp;
		ctrl->off += 6;
		return PLAYMODE;
	}
	else if (strncmp(&ctrl->str[ctrl->off],"ki_our",6) == 0 && isEndOfToken(ctrl->str[ctrl->off+6]))
	{
		lvalp->md = ki_our;
		ctrl->off += 6;
		return PLAYMODE;
	}
	else if (strncmp(&ctrl->str[ctrl->off],"ki_opp",6) == 0 && isEndOfToken(ctrl->str[ctrl->off+6]))
	{
		lvalp->md = ki_opp;
		ctrl->off += 6;
		return PLAYMODE;
	}
	else if (strncmp(&ctrl->str[ctrl->off],"fk_our",6) == 0 && isEndOfToken(ctrl->str[ctrl->off+6]))
	{
		lvalp->md = fk_our;
		ctrl->off += 6;
		return PLAYMODE;
	}
	else if (strncmp(&ctrl->str[ctrl->off],"fk_opp",6) == 0 && isEndOfToken(ctrl->str[ctrl->off+6]))
	{
		lvalp->md = fk_opp;
		ctrl->off += 6;
		return PLAYMODE;
	}
	else if (strncmp(&ctrl->str[ctrl->off],"ck_our",6) == 0 && isEndOfToken(ctrl->str[ctrl->off+6]))
	{
		lvalp->md = ck_our;
		ctrl->off += 6;
		return PLAYMODE;
	}
	else if (strncmp(&ctrl->str[ctrl->off],"ck_opp",6) == 0 && isEndOfToken(ctrl->str[ctrl->off+6]))
	{
		lvalp->md = ck_opp;
		ctrl->off += 6;
		return PLAYMODE;
	}
	else if (strncmp(&ctrl->str[ctrl->off],"gc_our",6) == 0 && isEndOfToken(ctrl->str[ctrl->off+6]))
	{
		lvalp->md = gc_our;
		ctrl->off += 6;
		return PLAYMODE;
	}
	else if (strncmp(&ctrl->str[ctrl->off],"gc_opp",6) == 0 && isEndOfToken(ctrl->str[ctrl->off+6]))
	{
		lvalp->md = gc_opp;
		ctrl->off += 6;
		return PLAYMODE;
	}
	else if (strncmp(&ctrl->str[ctrl->off],"ag_our",6) == 0 && isEndOfToken(ctrl->str[ctrl->off+6]))
	{
		lvalp->md = ag_our;
		ctrl->off += 6;
		return PLAYMODE;
	}
	else if (strncmp(&ctrl->str[ctrl->off],"ag_opp",6) == 0 && isEndOfToken(ctrl->str[ctrl->off+6]))
	{
		lvalp->md = ag_opp;
		ctrl->off += 6;
		return PLAYMODE;
	}
        else if (strncmp(&ctrl->str[ctrl->off],"gk_our",6) == 0 && isEndOfToken(ctrl->str[ctrl->off+6]))
	{
		lvalp->md = gk_our;
		ctrl->off += 6;
		return PLAYMODE;
	}
	else if (strncmp(&ctrl->str[ctrl->off],"gk_opp",6) == 0 && isEndOfToken(ctrl->str[ctrl->off+6]))
	{
		lvalp->md = gk_opp;
		ctrl->off += 6;
		return PLAYMODE;
	}
	else if (strncmp(&ctrl->str[ctrl->off],"dont",4) == 0 && isEndOfToken(ctrl->str[ctrl->off+4]))
	{

		ctrl->off += 4;
		return dirdont;
	}
	else if (strncmp(&ctrl->str[ctrl->off],"do",2) == 0 && isEndOfToken(ctrl->str[ctrl->off+2]))
	{

		ctrl->off += 2;
		return dirdo;
	}
	else if (strncmp(&ctrl->str[ctrl->off],"model",5) == 0 && isEndOfToken(ctrl->str[ctrl->off+5]))
	{

		ctrl->off += 5;
		return model;
	}
	else if (strncmp(&ctrl->str[ctrl->off],"direc",5) == 0 && isEndOfToken(ctrl->str[ctrl->off+5]))
	{

		ctrl->off += 5;
		return direc;
	}
	else if (strncmp(&ctrl->str[ctrl->off],"definerule",10) == 0 && isEndOfToken(ctrl->str[ctrl->off+10]))
	{

		ctrl->off += 10;
		return definerule;
	}
	else if (strncmp(&ctrl->str[ctrl->off],"definer",7) == 0 && isEndOfToken(ctrl->str[ctrl->off+7]))
	{

		ctrl->off += 7;
		return definer;
	}
	else if (strncmp(&ctrl->str[ctrl->off],"definea",7) == 0 && isEndOfToken(ctrl->str[ctrl->off+7]))
	{

		ctrl->off += 7;
		return definea;
	}
	else if (strncmp(&ctrl->str[ctrl->off],"defined",7) == 0 && isEndOfToken(ctrl->str[ctrl->off+7]))
	{
		
		ctrl->off += 7;
		return definedir;
	}
	else if (strncmp(&ctrl->str[ctrl->off],"definec",7) == 0 && isEndOfToken(ctrl->str[ctrl->off+7]))
	{
		
		ctrl->off += 7;
		return definec;
	}
	else if (strncmp(&ctrl->str[ctrl->off],"define",6) == 0 && isEndOfToken(ctrl->str[ctrl->off+6]))
	{
		
		ctrl->off += 7;
		return define;
	}
	else if (strncmp(&ctrl->str[ctrl->off],"delete",6) == 0 && isEndOfToken(ctrl->str[ctrl->off+6]))
	{
		
		ctrl->off += 6;
		return deleterule;
	}
	else if (strncmp(&ctrl->str[ctrl->off],"rule",4) == 0 && isEndOfToken(ctrl->str[ctrl->off+4]))
	{

		ctrl->off += 4;
		return ruletoken;
	}
	else if (strncmp(&ctrl->str[ctrl->off],"on",2) == 0 && isEndOfToken(ctrl->str[ctrl->off+2]))
	{

		ctrl->off += 2;
		return ruleon;
	}
	else if (strncmp(&ctrl->str[ctrl->off],"off",3) == 0 && isEndOfToken(ctrl->str[ctrl->off+3]))
	{

		ctrl->off += 3;
		return ruleoff;
	}
	else if (strncmp(&ctrl->str[ctrl->off],"all",3) == 0 && isEndOfToken(ctrl->str[ctrl->off+3]))
	{

		ctrl->off += 3;
		return allrules;
	}
	else if (isInteger(&ctrl->str[ctrl->off]))
	{
		char *ep;
		lvalp->integer = strtol(&ctrl->str[ctrl->off],&ep,10);

		ctrl->off = (ep - ctrl->str);
		return INTEGER;
	}
	else if (isDouble(&ctrl->str[ctrl->off]))
	{
		char *ep;
		lvalp->real = strtof(&ctrl->str[ctrl->off],&ep);
		
		ctrl->off = (ep - ctrl->str);
		return DOUBLE;		
	}
	else
	{
		char cs[255];
		int cso = 0;
		while (!isEndOfToken(ctrl->str[ctrl->off]))
		{
			cs[cso++] = ctrl->str[ctrl->off++];
		}
		cs[cso] = '\0';
		lvalp->clv = new CLangVar(cs);
		if (rulebase->IsDefinedVar(lvalp->clv))
			return DEFCV;
		else
			return UNDEFCV;

	}
}

int yyerror(char *s)
{
	char *c = strchr(s,',');
	if (c)
		*c = ':';
	cerr << "CLang " << s << endl;
	cout << "CLang " << s << endl;
	cout << "err" << endl;
	return 0;
}



